"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.runLighthouseReport = void 0;
const child_process_1 = require("child_process");
const lighthouseCli = require.resolve('lighthouse/lighthouse-cli');
// This function is marked as async to wrap it with a promise to make error handling easier
// Even though the underlying process is spawned synchronously
// eslint-disable-next-line @cloudfour/typescript-eslint/require-await
exports.runLighthouseReport = async (url) => {
    const { status = -1, stdout } = child_process_1.spawnSync('node', [
        lighthouseCli,
        url,
        '--output=csv',
        '--output-path=stdout',
        '--emulated-form-factor=mobile',
        '--only-categories=performance',
        '--chrome-flags="--headless"',
        '--max-wait-for-load=45000',
    ]);
    if (status !== 0) {
        throw new Error(`Lighthouse report failed for: ${url}`);
    }
    return String(stdout).replace(/\r\n/g, '\n');
};
